#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivExchange.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivExchange> M_ActivExchange::msSingleton(nullptr);

int M_ActivExchange::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivExchangeData* M_ActivExchange::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivExchangeData>& M_ActivExchange::GetMapData()
{
	return mMapData;
}

void M_ActivExchange::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivExchange::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivExchangeData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* ExchangeItems = element->Attribute("ExchangeItems");
			std::vector<std::string> vecExchangeItems;
			boost::split(vecExchangeItems, ExchangeItems, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecExchangeItems.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecExchangeItems[i].c_str(), &temp))
				{
					data.mExchangeItems.push_back(temp);
				}
			}
		}
		{
			const char* QuantityRequired = element->Attribute("QuantityRequired");
			std::vector<std::string> vecQuantityRequired;
			boost::split(vecQuantityRequired, QuantityRequired, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecQuantityRequired.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecQuantityRequired[i].c_str(), &temp))
				{
					data.mQuantityRequired.push_back(temp);
				}
			}
		}
		data.mGetItems = element->IntAttribute("GetItems");
		data.mGetQuantity = element->IntAttribute("GetQuantity");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivExchange::Load()
{
	Load("../Config/M_ActivExchange.xml");
}

M_ActivExchange* M_ActivExchange::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivExchange());
	}
	return msSingleton.get();
}
